--[[
	nowagepayment.lua
	--- IN DEVELOPMENT ---
	version: 0.1.2.0
	date: 21/12/18
	author: BigBlueHH
]]

NoWagePayment = {}
NoWagePayment.aiCostsPerRealHour = 1000
NoWagePayment.enteredVehicleIDs = {}

function NoWagePayment.prerequisitesPresent(specializations)
	return true
end

function NoWagePayment.registerEventListeners(vehicleType)
  for _,n in pairs( { "onEnterVehicle","onLeaveVehicle" } ) do
		SpecializationUtil.registerEventListener(vehicleType, n, NoWagePayment)
	end
end

function NoWagePayment:loadMap(name)
  AIJob.getPricePerMs = Utils.overwrittenFunction(AIJob.getPricePerMs, NoWagePayment.getPricePerMs)
  AIJobFieldWork.getPricePerMs = Utils.overwrittenFunction(AIJobFieldWork.getPricePerMs, NoWagePayment.getPricePerMs)
  AIJobConveyor.getPricePerMs = Utils.overwrittenFunction(AIJobConveyor.getPricePerMs, NoWagePayment.getPricePerMs)
  AbstractFieldMission.finish = Utils.appendedFunction(AbstractFieldMission.finish, NoWagePayment.finishFieldMission)
end

function NoWagePayment:onEnterVehicle()
	NoWagePayment.enteredVehicleIDs[self.id] = true
end

function NoWagePayment:onLeaveVehicle()
	NoWagePayment.enteredVehicleIDs[self.id] = nil
end

function NoWagePayment:getPricePerMs(sFunc)
	if NoWagePayment.enteredVehicleIDs[self.vehicleParameter.vehicleId] ~= nil then
		return 0
	else
		if NoWagePayment.aiCostsPerRealHour == 0 then
			return sFunc()
		else
			local pricePerMs = NoWagePayment.aiCostsPerRealHour/1000/60/60
			return pricePerMs
		end
	end	
end

function NoWagePayment:finishFieldMission(success)
  if success then
    for _,j in ipairs(self.mission.aiSystem.activeJobs) do
      local id = j.vehicleParameter.vehicleId
      for _,v in pairs(g_currentMission.vehicles) do
        if v.id == id and v.getIsAIActive ~= nil and v:getIsAIActive() then
          v:stopCurrentAIJob(AIMessageSuccessStoppedByUser.new())
        end
      end
    end
  end
end

addModEventListener(NoWagePayment)